class Game{
	// 	=========	declare variables
	var ship:Spaceship;
	var enemyArray:Array;
	var laserArray:Array;
	var dir:String;
	var bulletNum:Number = 0;
	var score:Number;
	var lives:Number;
	
	// ====   constructor  ============== 
	function Game(_ship:Spaceship, _enArray:Array, 
		_bullArray:Array){
		ship       = _ship;
		enemyArray = _enArray;
		laserArray = _bullArray;
		score = 0;
		lives = 10;
	}
	
	// ====  check key press method =======
	function checkKey():String{
	if(Key.isDown(Key.RIGHT)){
	dir = "right";
	}
	else if(Key.isDown(Key.LEFT)){
	dir = "left";
	}
	else if(Key.isDown(Key.UP)){
	dir = "up";
	}
	else if(Key.isDown(Key.DOWN)){
	dir = "down";
	}
	else dir="stop";
	
	return dir;
	}
	
	// ===  moveship method	=====
	// 1. check for keyPresses
	// 2. assign variable dir as per 1
	// 3 pass dir to spaceship.move
	function moveShip(dir:String){
	ship.move(checkKey());

	}
	
	//	=========	FIRE LASER	======	//
	function fireLaser(){
		if(Key.isDown(Key.SPACE)){
			// set start pt 
			laserArray[bulletNum]._y = ship.getY();
			laserArray[bulletNum]._x = ship.getX(); 
			// increment the bullet number
			++bulletNum;
			// if more than 5 bullets , start again at 0
			if (bulletNum>5) {
				bulletNum = 0;
				}
		}
	}
	
	//	=======	MOVE LASER	=======	//
	function moveLaser(){
		var bulleti = 0;
		while (bulleti<6) {
		laserArray[bulleti]._x += 30;
		bulleti++;
		}
	}	//	=============	//
	
	// move enemies
	function moveBaddies(){
		for(var i=0;i<3;i++){
			enemyArray[i].moveEnemy();
		}
	}
	
	// Collision Detection 
	function collision(){
	for(var j = 0; j<6;j++){
		for(var k=0;k<3;k++){
			// check bullets hit baddies 
			if(laserArray[j].hitTest(enemyArray[k])){
				score += 10;
				_root.score_txt.text = " Score: " + score;
				// explode the mofo
				_root.attachMovie("splode", "splode", 301);
				// set explosion to baddy coords
				_root.splode._x = enemyArray[k]._x;
				_root.splode._y = enemyArray[k]._y;
				// reset the baddy to stage right
				enemyArray[k].reset();
				}// end if
			// check baddies hit ship
			if(enemyArray[k].hitTest(ship)){
				enemyArray[k].reset();
				lives -= 1 ;
				_root.lives_txt.text = " Lives : " + lives;
				_root.attachMovie("splode", "splode", 301);
				// set explosion to ship coords
				_root.splode._x = ship._x;
				_root.splode._y = ship._y;
				// change color
				var my_color:Color = new Color(_root.splode);
				my_color.setRGB(0xff0000);
				// change size
				_root.splode._xscale = _root.splode._yscale = 400;
			}
			}
		}
	}
		
}	// 	------	END CLASS	-------	//
	